/*
 * SolucionExpedienteXno1.java
 *
 * Creado el 29 de noviembre de 2005, 11:00
 */


package computacion.practica1;

/**
 * Expediente X nmero 1
 *
 * Tericamente, la aplicacin debera escribir 3455.23 y 12.6;
 * sin embargo escribe 3455.23 y 3455.23. El motivo es que al igualar
 * matrices en el mtodo cambiar (c = b) y modificar c[0] (c[0] = 3455.23),
 * esta modificacin afecta a b y por tanto al vector a de la aplicacin. As
 * pues, el vector a que estamos usando en el mtodo nocambiar es
 * a = {3455.0, 2.3, 6.28}.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class SolucionExpedienteXno1 {
    
    public static void main(String[]args) {
        double[] a = {12.6, 2.3, 6.28};
        SolucionAuxExpedienteXno1 aux = new SolucionAuxExpedienteXno1();
       
        System.out.println(aux.cambiar(a)[0]);
        System.out.println(aux.nocambiar(a)[0]);
    }
    
}


