/*
 * Ejercicio4.java
 *
 * Creado el 12 de marzo de 2006, 12:50
 */


package ecuacionesPolinomicas.practica9;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio3 {
    
    public static void main(String[] args) {
        double[][] A;
        double[][] SolA;
        double valPropio;
        Polinomio p = new Polinomio();
        Polinomio q = new Polinomio();
        
        for (int n = 2; n <= 10; n++) {
            A = new double[n][n];
            for (int k = 0; k < n - 1; k++) {
                A[k][k + 1] = 1;
                A[k + 1][k] = 1;
            }
            
            try {
                System.out.println();
                System.out.println("Bsqueda de valores propios de A_"
                        + n + " mediante el mtodo de Jacobi:");
                SolA = Matrices.jacobiPropios(A, 1E-5, 200);
                for(int k = 0; k < n; k++) {
                    System.out.println("Valor propio " + (k + 1)
                            + ": h_" + (k + 1) + " = " + SolA[k][n]);
                }
            } catch(Matrices.ErrorMetodosLineales err) {
            }
            
            try {
                System.out.println();
                System.out.println("Bsqueda de valores propios de A_"
                        + n + " calculando y resolviendo " 
                        + "la ecuacin caracterstica:");
                p = Matrices.polinomioCaracteristico(A);
                System.out.println();
                System.out.println("Polinomio caracterstico de A_"
                        + n + ": " + p);
            } catch(Matrices.ErrorMetodosLineales errMetodosLineales) {
            }
            
            try {                
                q = new Polinomio(p);
                for(int k = 0; k < n; k++) {
                    valPropio = q.newton(q.cotaRaices(), 0.5E-14, 100);
                    System.out.print("Valor propio " + (k + 1)
                            + ": h_" + (k + 1) + " = " + valPropio);
                    System.out.println("   Evaluacin de h_" + (k + 1)
                            + ": p(h_" + (k + 1) + ") = "
                            + p.eval(valPropio));
                    q = q.deflacion(valPropio);
                }
            } catch(Polinomio.ErrorPolinomios errPolinomios) {
            }

        }
    }
    
}

