/*
 * Ejercicio3.java
 *
 * Creado el 20 de mayo de 2006, 21:25
 */


package interpolacionYAproximacion.practica10;
import auxiliar.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio3 {
    
    public static void main(String[] args) {
        PanelDibujo pd = new PanelDibujo("Grfica polinomial");        
        double[][] xy = {{- 4, 1}, {- 3, 2}, {- 2, 1}, {- 1, 0}, {0, - 2}, 
                {1, 0}, {2, 2}, {3, 3}, {4, 0}};
        double[] c = {-1.519, 0.319, 1.219,-0.025,-0.111, 0, 0.003};        
        Polinomio pol = new Polinomio(c);
                        
        pd.addEjesCoordenados(true);
        pd.addCurva("rojo", pol, 100, - 5, 5);        
        for (int i = 0; i < xy.length; i++) {
            pd.addCurva("azul", xy[i][0], xy[i][1], true);
        }                      
        pd.repaint();
        
        /**
         * Ntese que con la eleccin de ejes e intervalo que hacemos para 
         * representar el polinomio, parte de la grfica de ste queda fuera 
         * de la ventana. Como se ve, esto no genera ningn tipo de error en el 
         * programa.
         */
        System.out.println("Valor del polinomio para x = -5: " + pol.eval(- 5));
        System.out.println("Valor del polinomio para x = 5: " + pol.eval(5));
                
        pd.addWindowListener(
                new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        }
        );
        
        
    }
    
}
