/*
 * Ejercicio4.java
 *
 * Creado el 28 de noviembre de 2007, 11:01
 */


package metodosLineales.practica4;
import auxiliar.*;

/**
 * Como la presente prctica ilustra los nmeros de condicin de la matriz A
 * son bastante elevados, lo que explica que el problema de resolver sistemas 
 * lineales con A como matriz de coeficientes presente mucha sensibilidad.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio4 {
    
    public static void main(String[] args) {
        double[][] A = {{10, 7, 8, 7}, {7, 5, 6, 5}, {8, 6, 10, 9}, 
                {7, 5, 9, 10}};                
        double[][] InvA = {{25, -41, 10, -6}, {-41, 68, -17, 10},
                {10, -17, 5, -3}, {-6, 10, -3, 2}};
        double radioA;
        double radioInvA;
        double cond1;
        double cond2;
        
        try {
            System.out.println("Clculo del radio espectral aproximado de" 
                    + " la matriz A:");
            radioA = Matrices.aproxRadioEspectral(A); 
            System.out.println("Radio espectral aproximado de A : " + radioA);
            System.out.println("");
            System.out.println("Clculo del radio espectral aproximado de" 
                    + " la matriz A^{-1}:");
            radioInvA = Matrices.aproxRadioEspectral(InvA);
            System.out.println("Radio espectral aproximado de A^{-1} : " 
                    + radioInvA);
            
            /**
             * Para hallar una cota inferior de cond_2(A) usamos 
             * que el radio espectral de una matriz no puede ser mayor que 
             * ninguna de sus normas matriciales, con lo que en particular
             *   cond_2(A) = ||A||_2 ||A^{-1}|_2 <= rho(A) rho(A^{-1), 
             * donde rho denota al radio espectral.
             */
            System.out.println("Cota inferior de cond_2(A): " 
                    + (radioA * radioInvA));
            System.out.println("cond_1(A) = " 
                    + (Matrices.norma1(A) * Matrices.norma1(InvA)) );          
        } catch(Matrices.ErrorMetodosLineales err) {
        }               
    }
    
}
