/*
 * Ejercicio3.java
 *
 * Creado el 2 de marzo de 2007, 20:09
 */


package metodosLineales.practica8;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio3 {
    
    public static void main(String[] args) {        
        double[][] A = {{-2, 0, 1, 1}, {-5, -5, 4, 5}, 
                {16, 14, -8, -12}, {-19, -15, 11, 15}};        
        double[][] Id = {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, 
                {0, 0, 0, 1}};
        double[][] SolA;
        double[][] InvA;
        double[] v = {1, 0, 0, 0};
        double[] y = {1, 0, 0, 0};
        double[] ulambda = new double[5];
        double[] u = new double[4];
        double lambda; 
        
        try {
            System.out.println();
            System.out.println("Matriz A:");
            System.out.println(Matrices.toString(A));
            System.out.println("Aplicamos el mtodo de deflacin de Wielandt");
            SolA = Matrices.deflacionWielandt(A, 1E-5, 10000);
        } catch(Matrices.ErrorMetodosLineales err) {
        }   
        
        try {  
            
            /**
             * Calculamos lambda_1 aplicando el mtodo de la potencia a 
             * A + Id.
             */
            System.out.println();
            ulambda = Matrices.potencia(Matrices.suma(A, Id), 1E-14, 300, v, y);
            for (int i = 0; i < 4; i++) {
                u[i] = ulambda[i];
            }
            lambda = ulambda[4] - 1;
            System.out.println("Valor propio lambda_1:" );
            System.out.println(lambda);
            System.out.println("Vector propio u correspondiente:" );
            System.out.println(Matrices.toString(u));
            System.out.println("Vector Au - lambda_1 u: ");
            System.out.println(Matrices.toString(
                    Matrices.resta(Matrices.producto(A, u),
                    Matrices.producto(lambda, u))));
            
            /**
             * Calculamos -lambda_1 aplicando el mtodo de la potencia a 
             * A - Id.
             */
            System.out.println();
            ulambda = Matrices.potencia(Matrices.resta(A, Id), 1E-14, 300, v, y);                        
            for (int i = 0; i < 4; i++) {
                u[i] = ulambda[i];
            }
            lambda = ulambda[4] + 1;
            System.out.println("Valor propio -lambda_1:" );
            System.out.println(lambda);
            System.out.println("Vector propio u correspondiente:" );
            System.out.println(Matrices.toString(u));  
                       System.out.println("Vector Au + lambda_1 u: ");
            System.out.println(Matrices.toString(
                    Matrices.resta(Matrices.producto(A, u),
                    Matrices.producto(lambda, u))));
    
          
            /**
             * Calculamos lambda_2 aplicando el mtodo de la potencia a 
             * A^{-1} + Id.
             */
            System.out.println();
            InvA = Matrices.inversa(A);
            ulambda = Matrices.potencia(
                    Matrices.suma(InvA, Id), 1E-14, 400, v, y);
            for (int i = 0; i < 4; i++) {
                u[i] = ulambda[i];
            }
            lambda = 1 / (ulambda[4] - 1);
            System.out.println("Valor propio lambda_2:" );
            System.out.println(lambda);
            System.out.println("Vector propio u correspondiente:" );
            System.out.println(Matrices.toString(u));
            System.out.println("Vector Au - lambda_2 u: ");
            System.out.println(Matrices.toString(
                    Matrices.resta(Matrices.producto(A, u),
                    Matrices.producto(lambda, u))));

            /**
             * Calculamos -lambda_2 aplicando el mtodo de la potencia a 
             * A^{-1} - Id.
             */            
            System.out.println();
            ulambda = Matrices.potencia(
                    Matrices.resta(InvA, Id), 1E-14, 400, v, y);                        
            for (int i = 0; i < 4; i++) {
                u[i] = ulambda[i];
            }
            lambda = 1 / (ulambda[4] + 1);
            System.out.println("Valor propio -lambda_2:" );
            System.out.println(lambda);
            System.out.println("Vector propio u correspondiente:" );
            System.out.println(Matrices.toString(u));  
                       System.out.println("Vector Au + lambda_2 u: ");
            System.out.println(Matrices.toString(
                    Matrices.resta(Matrices.producto(A, u),
                    Matrices.producto(lambda, u))));
                      
        } catch(Matrices.ErrorMetodosLineales err) {
        }   
        
    }    
    
}
