/*
 * FuncionEj3.java
 *
 * Creado el 26 de diciembre de 2005, 22:57
 */


package computacion.practica3;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class FuncionEj3 implements auxiliar.Funcion {
    double mu;
    double mu1;
    double g;
    double n;
    double p;
    double v;
    double a;
    double b;
 
    public FuncionEj3(double par_mu, double par_mu1, double par_g, double par_n,
            double par_p, double par_v) {
        mu = par_mu;
        mu1 = par_mu1;
        g = par_g;
        n = par_n;
        p = par_p;
        v = par_v;
        a = 2. / 9. * g / n * (mu - mu1);
        b = a * .000617 / p;
    }    
    
    public double eval(double r) {
        return a * r * r + b * r - v;
    }
    
    public double derivada(double r) {
        return 2 * a * r + b;
    }
    
}
