/*
 * Ejercicio6.java
 *
 * Creado el 2 de marzo de 2007, 21:17
 */


package metodosLineales.practica8;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio6 {
    
    public static void main(String[] args) {
        int k = 15;
        double[][] A = new double[k][k];       
        double[][] SolA = new double[k][k + 1];
        double[] v = new double[k];
        double lambda;
        
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                A[i][j] = i + j + 1;
            }
        }
        
        try {
            System.out.println();
            System.out.println("Matriz A:");
            System.out.println(Matrices.toString(A));
            System.out.println();
            System.out.println("Aplicamos el mtodo de deflacin de Wielandt");
            SolA = Matrices.deflacionWielandt(A, 1E-5, 10000);
        } catch(Matrices.ErrorMetodosLineales err) {
        }
        
        try {
            System.out.println(); 
            System.out.println("Aplicamos el mtodo de Jacobi");
            SolA = Matrices.jacobiPropios(A, 1E-5, 100);            
            for(int i = 0; i < k; i++) {
                for(int j = 0; j < k; j++) {
                    v[j] = SolA[i][j];
                }  
                lambda = SolA[i][k];
                System.out.println("Vector propio v_{" + (i + 1) + "}:" );
                System.out.println(Matrices.toString(v));
                System.out.println("Valor propio lambda_{" + (i + 1) + "}:" );
                System.out.println(lambda);
                System.out.println("Vector Av_{" + (i + 1) + "} " 
                        + "- lambda_{" + (i + 1) + "}v_{" + (i + 1) + "}:");                                
                System.out.println(Matrices.toString(
                        Matrices.resta(Matrices.producto(A, v), 
                        Matrices.producto(lambda, v))) );
            }
            System.out.println("Como la matriz formada por los vectores " 
                    + "v_1,... , v_{15}, es ortogonal y hemos comprobado ");
            System.out.println("que son vectores propios, formarn una " 
                    + "base de vectores propios (aunque a priori no tenemos ");
            System.out.println("un teorema de convergencia que lo asegure " 
                    + "porque los valores propios estn repetidos).");
            System.out.println();                        
        } catch(Matrices.ErrorMetodosLineales err) {
        }       
    }
    
}
